# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ExternalVolumeArgs', 'ExternalVolume']

@pulumi.input_type
class ExternalVolumeArgs:
    def __init__(__self__, *,
                 capabilities: pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]],
                 plugin_id: pulumi.Input[str],
                 volume_id: pulumi.Input[str],
                 capacity_max: Optional[pulumi.Input[str]] = None,
                 capacity_min: Optional[pulumi.Input[str]] = None,
                 clone_id: Optional[pulumi.Input[str]] = None,
                 mount_options: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 topology_request: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ExternalVolume resource.
        :param pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]] capabilities: `(``Capability``: <required>)` - Options for validating the capability of a volume.
        :param pulumi.Input[str] plugin_id: `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        :param pulumi.Input[str] volume_id: `(string: <required>)` - The unique ID of the volume.
        :param pulumi.Input[str] capacity_max: `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] capacity_min: `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] clone_id: `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        :param pulumi.Input['ExternalVolumeMountOptionsArgs'] mount_options: `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        :param pulumi.Input[str] name: `(string: <required>)` - The display name for the volume.
        :param pulumi.Input[str] namespace: `(string: "default")` - The namespace in which to register the volume.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] secrets: `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        :param pulumi.Input[str] snapshot_id: `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        :param pulumi.Input['ExternalVolumeTopologyRequestArgs'] topology_request: `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        :param pulumi.Input[str] type: `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        """
        ExternalVolumeArgs._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            capabilities=capabilities,
            plugin_id=plugin_id,
            volume_id=volume_id,
            capacity_max=capacity_max,
            capacity_min=capacity_min,
            clone_id=clone_id,
            mount_options=mount_options,
            name=name,
            namespace=namespace,
            parameters=parameters,
            secrets=secrets,
            snapshot_id=snapshot_id,
            topology_request=topology_request,
            type=type,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             capabilities: pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]],
             plugin_id: pulumi.Input[str],
             volume_id: pulumi.Input[str],
             capacity_max: Optional[pulumi.Input[str]] = None,
             capacity_min: Optional[pulumi.Input[str]] = None,
             clone_id: Optional[pulumi.Input[str]] = None,
             mount_options: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']] = None,
             name: Optional[pulumi.Input[str]] = None,
             namespace: Optional[pulumi.Input[str]] = None,
             parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             snapshot_id: Optional[pulumi.Input[str]] = None,
             topology_request: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']] = None,
             type: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("capabilities", capabilities)
        _setter("plugin_id", plugin_id)
        _setter("volume_id", volume_id)
        if capacity_max is not None:
            _setter("capacity_max", capacity_max)
        if capacity_min is not None:
            _setter("capacity_min", capacity_min)
        if clone_id is not None:
            _setter("clone_id", clone_id)
        if mount_options is not None:
            _setter("mount_options", mount_options)
        if name is not None:
            _setter("name", name)
        if namespace is not None:
            _setter("namespace", namespace)
        if parameters is not None:
            _setter("parameters", parameters)
        if secrets is not None:
            _setter("secrets", secrets)
        if snapshot_id is not None:
            _setter("snapshot_id", snapshot_id)
        if topology_request is not None:
            _setter("topology_request", topology_request)
        if type is not None:
            _setter("type", type)

    @property
    @pulumi.getter
    def capabilities(self) -> pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]:
        """
        `(``Capability``: <required>)` - Options for validating the capability of a volume.
        """
        return pulumi.get(self, "capabilities")

    @capabilities.setter
    def capabilities(self, value: pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]):
        pulumi.set(self, "capabilities", value)

    @property
    @pulumi.getter(name="pluginId")
    def plugin_id(self) -> pulumi.Input[str]:
        """
        `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        """
        return pulumi.get(self, "plugin_id")

    @plugin_id.setter
    def plugin_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "plugin_id", value)

    @property
    @pulumi.getter(name="volumeId")
    def volume_id(self) -> pulumi.Input[str]:
        """
        `(string: <required>)` - The unique ID of the volume.
        """
        return pulumi.get(self, "volume_id")

    @volume_id.setter
    def volume_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "volume_id", value)

    @property
    @pulumi.getter(name="capacityMax")
    def capacity_max(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_max")

    @capacity_max.setter
    def capacity_max(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "capacity_max", value)

    @property
    @pulumi.getter(name="capacityMin")
    def capacity_min(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_min")

    @capacity_min.setter
    def capacity_min(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "capacity_min", value)

    @property
    @pulumi.getter(name="cloneId")
    def clone_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        """
        return pulumi.get(self, "clone_id")

    @clone_id.setter
    def clone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "clone_id", value)

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']]:
        """
        `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        """
        return pulumi.get(self, "mount_options")

    @mount_options.setter
    def mount_options(self, value: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']]):
        pulumi.set(self, "mount_options", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The display name for the volume.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: "default")` - The namespace in which to register the volume.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter
    def secrets(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        """
        return pulumi.get(self, "secrets")

    @secrets.setter
    def secrets(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "secrets", value)

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        """
        return pulumi.get(self, "snapshot_id")

    @snapshot_id.setter
    def snapshot_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snapshot_id", value)

    @property
    @pulumi.getter(name="topologyRequest")
    def topology_request(self) -> Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']]:
        """
        `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        """
        return pulumi.get(self, "topology_request")

    @topology_request.setter
    def topology_request(self, value: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']]):
        pulumi.set(self, "topology_request", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _ExternalVolumeState:
    def __init__(__self__, *,
                 capabilities: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]] = None,
                 capacity_max: Optional[pulumi.Input[str]] = None,
                 capacity_min: Optional[pulumi.Input[str]] = None,
                 clone_id: Optional[pulumi.Input[str]] = None,
                 controller_required: Optional[pulumi.Input[bool]] = None,
                 controllers_expected: Optional[pulumi.Input[int]] = None,
                 controllers_healthy: Optional[pulumi.Input[int]] = None,
                 mount_options: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None,
                 nodes_expected: Optional[pulumi.Input[int]] = None,
                 nodes_healthy: Optional[pulumi.Input[int]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 plugin_id: Optional[pulumi.Input[str]] = None,
                 plugin_provider: Optional[pulumi.Input[str]] = None,
                 plugin_provider_version: Optional[pulumi.Input[str]] = None,
                 schedulable: Optional[pulumi.Input[bool]] = None,
                 secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 topologies: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeTopologyArgs']]]] = None,
                 topology_request: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 volume_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ExternalVolume resources.
        :param pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]] capabilities: `(``Capability``: <required>)` - Options for validating the capability of a volume.
        :param pulumi.Input[str] capacity_max: `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] capacity_min: `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] clone_id: `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        :param pulumi.Input[bool] controller_required: `(boolean)`
        :param pulumi.Input[int] controllers_expected: `(integer)`
        :param pulumi.Input[int] controllers_healthy: `(integer)`
        :param pulumi.Input['ExternalVolumeMountOptionsArgs'] mount_options: `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        :param pulumi.Input[str] name: `(string: <required>)` - The display name for the volume.
        :param pulumi.Input[str] namespace: `(string: "default")` - The namespace in which to register the volume.
        :param pulumi.Input[int] nodes_expected: `(integer)`
        :param pulumi.Input[int] nodes_healthy: `(integer)`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        :param pulumi.Input[str] plugin_id: `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        :param pulumi.Input[str] plugin_provider: `(string)`
        :param pulumi.Input[str] plugin_provider_version: `(string)`
        :param pulumi.Input[bool] schedulable: `(boolean)`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] secrets: `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        :param pulumi.Input[str] snapshot_id: `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        :param pulumi.Input[Sequence[pulumi.Input['ExternalVolumeTopologyArgs']]] topologies: `(List of topologies)`
        :param pulumi.Input['ExternalVolumeTopologyRequestArgs'] topology_request: `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        :param pulumi.Input[str] type: `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        :param pulumi.Input[str] volume_id: `(string: <required>)` - The unique ID of the volume.
        """
        _ExternalVolumeState._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            capabilities=capabilities,
            capacity_max=capacity_max,
            capacity_min=capacity_min,
            clone_id=clone_id,
            controller_required=controller_required,
            controllers_expected=controllers_expected,
            controllers_healthy=controllers_healthy,
            mount_options=mount_options,
            name=name,
            namespace=namespace,
            nodes_expected=nodes_expected,
            nodes_healthy=nodes_healthy,
            parameters=parameters,
            plugin_id=plugin_id,
            plugin_provider=plugin_provider,
            plugin_provider_version=plugin_provider_version,
            schedulable=schedulable,
            secrets=secrets,
            snapshot_id=snapshot_id,
            topologies=topologies,
            topology_request=topology_request,
            type=type,
            volume_id=volume_id,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             capabilities: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]] = None,
             capacity_max: Optional[pulumi.Input[str]] = None,
             capacity_min: Optional[pulumi.Input[str]] = None,
             clone_id: Optional[pulumi.Input[str]] = None,
             controller_required: Optional[pulumi.Input[bool]] = None,
             controllers_expected: Optional[pulumi.Input[int]] = None,
             controllers_healthy: Optional[pulumi.Input[int]] = None,
             mount_options: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']] = None,
             name: Optional[pulumi.Input[str]] = None,
             namespace: Optional[pulumi.Input[str]] = None,
             nodes_expected: Optional[pulumi.Input[int]] = None,
             nodes_healthy: Optional[pulumi.Input[int]] = None,
             parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             plugin_id: Optional[pulumi.Input[str]] = None,
             plugin_provider: Optional[pulumi.Input[str]] = None,
             plugin_provider_version: Optional[pulumi.Input[str]] = None,
             schedulable: Optional[pulumi.Input[bool]] = None,
             secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
             snapshot_id: Optional[pulumi.Input[str]] = None,
             topologies: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeTopologyArgs']]]] = None,
             topology_request: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']] = None,
             type: Optional[pulumi.Input[str]] = None,
             volume_id: Optional[pulumi.Input[str]] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if capabilities is not None:
            _setter("capabilities", capabilities)
        if capacity_max is not None:
            _setter("capacity_max", capacity_max)
        if capacity_min is not None:
            _setter("capacity_min", capacity_min)
        if clone_id is not None:
            _setter("clone_id", clone_id)
        if controller_required is not None:
            _setter("controller_required", controller_required)
        if controllers_expected is not None:
            _setter("controllers_expected", controllers_expected)
        if controllers_healthy is not None:
            _setter("controllers_healthy", controllers_healthy)
        if mount_options is not None:
            _setter("mount_options", mount_options)
        if name is not None:
            _setter("name", name)
        if namespace is not None:
            _setter("namespace", namespace)
        if nodes_expected is not None:
            _setter("nodes_expected", nodes_expected)
        if nodes_healthy is not None:
            _setter("nodes_healthy", nodes_healthy)
        if parameters is not None:
            _setter("parameters", parameters)
        if plugin_id is not None:
            _setter("plugin_id", plugin_id)
        if plugin_provider is not None:
            _setter("plugin_provider", plugin_provider)
        if plugin_provider_version is not None:
            _setter("plugin_provider_version", plugin_provider_version)
        if schedulable is not None:
            _setter("schedulable", schedulable)
        if secrets is not None:
            _setter("secrets", secrets)
        if snapshot_id is not None:
            _setter("snapshot_id", snapshot_id)
        if topologies is not None:
            _setter("topologies", topologies)
        if topology_request is not None:
            _setter("topology_request", topology_request)
        if type is not None:
            _setter("type", type)
        if volume_id is not None:
            _setter("volume_id", volume_id)

    @property
    @pulumi.getter
    def capabilities(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]]:
        """
        `(``Capability``: <required>)` - Options for validating the capability of a volume.
        """
        return pulumi.get(self, "capabilities")

    @capabilities.setter
    def capabilities(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeCapabilityArgs']]]]):
        pulumi.set(self, "capabilities", value)

    @property
    @pulumi.getter(name="capacityMax")
    def capacity_max(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_max")

    @capacity_max.setter
    def capacity_max(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "capacity_max", value)

    @property
    @pulumi.getter(name="capacityMin")
    def capacity_min(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_min")

    @capacity_min.setter
    def capacity_min(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "capacity_min", value)

    @property
    @pulumi.getter(name="cloneId")
    def clone_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        """
        return pulumi.get(self, "clone_id")

    @clone_id.setter
    def clone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "clone_id", value)

    @property
    @pulumi.getter(name="controllerRequired")
    def controller_required(self) -> Optional[pulumi.Input[bool]]:
        """
        `(boolean)`
        """
        return pulumi.get(self, "controller_required")

    @controller_required.setter
    def controller_required(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "controller_required", value)

    @property
    @pulumi.getter(name="controllersExpected")
    def controllers_expected(self) -> Optional[pulumi.Input[int]]:
        """
        `(integer)`
        """
        return pulumi.get(self, "controllers_expected")

    @controllers_expected.setter
    def controllers_expected(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "controllers_expected", value)

    @property
    @pulumi.getter(name="controllersHealthy")
    def controllers_healthy(self) -> Optional[pulumi.Input[int]]:
        """
        `(integer)`
        """
        return pulumi.get(self, "controllers_healthy")

    @controllers_healthy.setter
    def controllers_healthy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "controllers_healthy", value)

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']]:
        """
        `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        """
        return pulumi.get(self, "mount_options")

    @mount_options.setter
    def mount_options(self, value: Optional[pulumi.Input['ExternalVolumeMountOptionsArgs']]):
        pulumi.set(self, "mount_options", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The display name for the volume.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def namespace(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: "default")` - The namespace in which to register the volume.
        """
        return pulumi.get(self, "namespace")

    @namespace.setter
    def namespace(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "namespace", value)

    @property
    @pulumi.getter(name="nodesExpected")
    def nodes_expected(self) -> Optional[pulumi.Input[int]]:
        """
        `(integer)`
        """
        return pulumi.get(self, "nodes_expected")

    @nodes_expected.setter
    def nodes_expected(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "nodes_expected", value)

    @property
    @pulumi.getter(name="nodesHealthy")
    def nodes_healthy(self) -> Optional[pulumi.Input[int]]:
        """
        `(integer)`
        """
        return pulumi.get(self, "nodes_healthy")

    @nodes_healthy.setter
    def nodes_healthy(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "nodes_healthy", value)

    @property
    @pulumi.getter
    def parameters(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        """
        return pulumi.get(self, "parameters")

    @parameters.setter
    def parameters(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "parameters", value)

    @property
    @pulumi.getter(name="pluginId")
    def plugin_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        """
        return pulumi.get(self, "plugin_id")

    @plugin_id.setter
    def plugin_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "plugin_id", value)

    @property
    @pulumi.getter(name="pluginProvider")
    def plugin_provider(self) -> Optional[pulumi.Input[str]]:
        """
        `(string)`
        """
        return pulumi.get(self, "plugin_provider")

    @plugin_provider.setter
    def plugin_provider(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "plugin_provider", value)

    @property
    @pulumi.getter(name="pluginProviderVersion")
    def plugin_provider_version(self) -> Optional[pulumi.Input[str]]:
        """
        `(string)`
        """
        return pulumi.get(self, "plugin_provider_version")

    @plugin_provider_version.setter
    def plugin_provider_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "plugin_provider_version", value)

    @property
    @pulumi.getter
    def schedulable(self) -> Optional[pulumi.Input[bool]]:
        """
        `(boolean)`
        """
        return pulumi.get(self, "schedulable")

    @schedulable.setter
    def schedulable(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "schedulable", value)

    @property
    @pulumi.getter
    def secrets(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        """
        return pulumi.get(self, "secrets")

    @secrets.setter
    def secrets(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "secrets", value)

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        """
        return pulumi.get(self, "snapshot_id")

    @snapshot_id.setter
    def snapshot_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snapshot_id", value)

    @property
    @pulumi.getter
    def topologies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeTopologyArgs']]]]:
        """
        `(List of topologies)`
        """
        return pulumi.get(self, "topologies")

    @topologies.setter
    def topologies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ExternalVolumeTopologyArgs']]]]):
        pulumi.set(self, "topologies", value)

    @property
    @pulumi.getter(name="topologyRequest")
    def topology_request(self) -> Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']]:
        """
        `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        """
        return pulumi.get(self, "topology_request")

    @topology_request.setter
    def topology_request(self, value: Optional[pulumi.Input['ExternalVolumeTopologyRequestArgs']]):
        pulumi.set(self, "topology_request", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="volumeId")
    def volume_id(self) -> Optional[pulumi.Input[str]]:
        """
        `(string: <required>)` - The unique ID of the volume.
        """
        return pulumi.get(self, "volume_id")

    @volume_id.setter
    def volume_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "volume_id", value)


class ExternalVolume(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capabilities: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeCapabilityArgs']]]]] = None,
                 capacity_max: Optional[pulumi.Input[str]] = None,
                 capacity_min: Optional[pulumi.Input[str]] = None,
                 clone_id: Optional[pulumi.Input[str]] = None,
                 mount_options: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeMountOptionsArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 plugin_id: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 topology_request: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeTopologyRequestArgs']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 volume_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        Creating a volume:

        ```python
        import pulumi
        import pulumi_nomad as nomad

        ebs = nomad.get_plugin(plugin_id="aws-ebs0",
            wait_for_healthy=True)
        mysql_volume = nomad.ExternalVolume("mysqlVolume",
            type="csi",
            plugin_id="aws-ebs0",
            volume_id="mysql_volume",
            capacity_min="10GiB",
            capacity_max="20GiB",
            capabilities=[nomad.ExternalVolumeCapabilityArgs(
                access_mode="single-node-writer",
                attachment_mode="file-system",
            )],
            mount_options=nomad.ExternalVolumeMountOptionsArgs(
                fs_type="ext4",
            ),
            topology_request=nomad.ExternalVolumeTopologyRequestArgs(
                required=nomad.ExternalVolumeTopologyRequestRequiredArgs(
                    topologies=[
                        nomad.ExternalVolumeTopologyRequestRequiredTopologyArgs(
                            segments={
                                "rack": "R1",
                                "zone": "us-east-1a",
                            },
                        ),
                        nomad.ExternalVolumeTopologyRequestRequiredTopologyArgs(
                            segments={
                                "rack": "R2",
                            },
                        ),
                    ],
                ),
            ),
            opts=pulumi.ResourceOptions(depends_on=[ebs]))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeCapabilityArgs']]]] capabilities: `(``Capability``: <required>)` - Options for validating the capability of a volume.
        :param pulumi.Input[str] capacity_max: `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] capacity_min: `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] clone_id: `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        :param pulumi.Input[pulumi.InputType['ExternalVolumeMountOptionsArgs']] mount_options: `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        :param pulumi.Input[str] name: `(string: <required>)` - The display name for the volume.
        :param pulumi.Input[str] namespace: `(string: "default")` - The namespace in which to register the volume.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        :param pulumi.Input[str] plugin_id: `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] secrets: `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        :param pulumi.Input[str] snapshot_id: `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        :param pulumi.Input[pulumi.InputType['ExternalVolumeTopologyRequestArgs']] topology_request: `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        :param pulumi.Input[str] type: `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        :param pulumi.Input[str] volume_id: `(string: <required>)` - The unique ID of the volume.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ExternalVolumeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        Creating a volume:

        ```python
        import pulumi
        import pulumi_nomad as nomad

        ebs = nomad.get_plugin(plugin_id="aws-ebs0",
            wait_for_healthy=True)
        mysql_volume = nomad.ExternalVolume("mysqlVolume",
            type="csi",
            plugin_id="aws-ebs0",
            volume_id="mysql_volume",
            capacity_min="10GiB",
            capacity_max="20GiB",
            capabilities=[nomad.ExternalVolumeCapabilityArgs(
                access_mode="single-node-writer",
                attachment_mode="file-system",
            )],
            mount_options=nomad.ExternalVolumeMountOptionsArgs(
                fs_type="ext4",
            ),
            topology_request=nomad.ExternalVolumeTopologyRequestArgs(
                required=nomad.ExternalVolumeTopologyRequestRequiredArgs(
                    topologies=[
                        nomad.ExternalVolumeTopologyRequestRequiredTopologyArgs(
                            segments={
                                "rack": "R1",
                                "zone": "us-east-1a",
                            },
                        ),
                        nomad.ExternalVolumeTopologyRequestRequiredTopologyArgs(
                            segments={
                                "rack": "R2",
                            },
                        ),
                    ],
                ),
            ),
            opts=pulumi.ResourceOptions(depends_on=[ebs]))
        ```

        :param str resource_name: The name of the resource.
        :param ExternalVolumeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ExternalVolumeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            kwargs = kwargs or {}
            def _setter(key, value):
                kwargs[key] = value
            ExternalVolumeArgs._configure(_setter, **kwargs)
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capabilities: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeCapabilityArgs']]]]] = None,
                 capacity_max: Optional[pulumi.Input[str]] = None,
                 capacity_min: Optional[pulumi.Input[str]] = None,
                 clone_id: Optional[pulumi.Input[str]] = None,
                 mount_options: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeMountOptionsArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 namespace: Optional[pulumi.Input[str]] = None,
                 parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 plugin_id: Optional[pulumi.Input[str]] = None,
                 secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 topology_request: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeTopologyRequestArgs']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 volume_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ExternalVolumeArgs.__new__(ExternalVolumeArgs)

            if capabilities is None and not opts.urn:
                raise TypeError("Missing required property 'capabilities'")
            __props__.__dict__["capabilities"] = capabilities
            __props__.__dict__["capacity_max"] = capacity_max
            __props__.__dict__["capacity_min"] = capacity_min
            __props__.__dict__["clone_id"] = clone_id
            if mount_options is not None and not isinstance(mount_options, ExternalVolumeMountOptionsArgs):
                mount_options = mount_options or {}
                def _setter(key, value):
                    mount_options[key] = value
                ExternalVolumeMountOptionsArgs._configure(_setter, **mount_options)
            __props__.__dict__["mount_options"] = mount_options
            __props__.__dict__["name"] = name
            __props__.__dict__["namespace"] = namespace
            __props__.__dict__["parameters"] = parameters
            if plugin_id is None and not opts.urn:
                raise TypeError("Missing required property 'plugin_id'")
            __props__.__dict__["plugin_id"] = plugin_id
            __props__.__dict__["secrets"] = None if secrets is None else pulumi.Output.secret(secrets)
            __props__.__dict__["snapshot_id"] = snapshot_id
            if topology_request is not None and not isinstance(topology_request, ExternalVolumeTopologyRequestArgs):
                topology_request = topology_request or {}
                def _setter(key, value):
                    topology_request[key] = value
                ExternalVolumeTopologyRequestArgs._configure(_setter, **topology_request)
            __props__.__dict__["topology_request"] = topology_request
            __props__.__dict__["type"] = type
            if volume_id is None and not opts.urn:
                raise TypeError("Missing required property 'volume_id'")
            __props__.__dict__["volume_id"] = volume_id
            __props__.__dict__["controller_required"] = None
            __props__.__dict__["controllers_expected"] = None
            __props__.__dict__["controllers_healthy"] = None
            __props__.__dict__["nodes_expected"] = None
            __props__.__dict__["nodes_healthy"] = None
            __props__.__dict__["plugin_provider"] = None
            __props__.__dict__["plugin_provider_version"] = None
            __props__.__dict__["schedulable"] = None
            __props__.__dict__["topologies"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["secrets"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(ExternalVolume, __self__).__init__(
            'nomad:index/externalVolume:ExternalVolume',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            capabilities: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeCapabilityArgs']]]]] = None,
            capacity_max: Optional[pulumi.Input[str]] = None,
            capacity_min: Optional[pulumi.Input[str]] = None,
            clone_id: Optional[pulumi.Input[str]] = None,
            controller_required: Optional[pulumi.Input[bool]] = None,
            controllers_expected: Optional[pulumi.Input[int]] = None,
            controllers_healthy: Optional[pulumi.Input[int]] = None,
            mount_options: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeMountOptionsArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            namespace: Optional[pulumi.Input[str]] = None,
            nodes_expected: Optional[pulumi.Input[int]] = None,
            nodes_healthy: Optional[pulumi.Input[int]] = None,
            parameters: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            plugin_id: Optional[pulumi.Input[str]] = None,
            plugin_provider: Optional[pulumi.Input[str]] = None,
            plugin_provider_version: Optional[pulumi.Input[str]] = None,
            schedulable: Optional[pulumi.Input[bool]] = None,
            secrets: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            snapshot_id: Optional[pulumi.Input[str]] = None,
            topologies: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeTopologyArgs']]]]] = None,
            topology_request: Optional[pulumi.Input[pulumi.InputType['ExternalVolumeTopologyRequestArgs']]] = None,
            type: Optional[pulumi.Input[str]] = None,
            volume_id: Optional[pulumi.Input[str]] = None) -> 'ExternalVolume':
        """
        Get an existing ExternalVolume resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeCapabilityArgs']]]] capabilities: `(``Capability``: <required>)` - Options for validating the capability of a volume.
        :param pulumi.Input[str] capacity_max: `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] capacity_min: `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        :param pulumi.Input[str] clone_id: `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        :param pulumi.Input[bool] controller_required: `(boolean)`
        :param pulumi.Input[int] controllers_expected: `(integer)`
        :param pulumi.Input[int] controllers_healthy: `(integer)`
        :param pulumi.Input[pulumi.InputType['ExternalVolumeMountOptionsArgs']] mount_options: `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        :param pulumi.Input[str] name: `(string: <required>)` - The display name for the volume.
        :param pulumi.Input[str] namespace: `(string: "default")` - The namespace in which to register the volume.
        :param pulumi.Input[int] nodes_expected: `(integer)`
        :param pulumi.Input[int] nodes_healthy: `(integer)`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] parameters: `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        :param pulumi.Input[str] plugin_id: `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        :param pulumi.Input[str] plugin_provider: `(string)`
        :param pulumi.Input[str] plugin_provider_version: `(string)`
        :param pulumi.Input[bool] schedulable: `(boolean)`
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] secrets: `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        :param pulumi.Input[str] snapshot_id: `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ExternalVolumeTopologyArgs']]]] topologies: `(List of topologies)`
        :param pulumi.Input[pulumi.InputType['ExternalVolumeTopologyRequestArgs']] topology_request: `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        :param pulumi.Input[str] type: `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        :param pulumi.Input[str] volume_id: `(string: <required>)` - The unique ID of the volume.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ExternalVolumeState.__new__(_ExternalVolumeState)

        __props__.__dict__["capabilities"] = capabilities
        __props__.__dict__["capacity_max"] = capacity_max
        __props__.__dict__["capacity_min"] = capacity_min
        __props__.__dict__["clone_id"] = clone_id
        __props__.__dict__["controller_required"] = controller_required
        __props__.__dict__["controllers_expected"] = controllers_expected
        __props__.__dict__["controllers_healthy"] = controllers_healthy
        __props__.__dict__["mount_options"] = mount_options
        __props__.__dict__["name"] = name
        __props__.__dict__["namespace"] = namespace
        __props__.__dict__["nodes_expected"] = nodes_expected
        __props__.__dict__["nodes_healthy"] = nodes_healthy
        __props__.__dict__["parameters"] = parameters
        __props__.__dict__["plugin_id"] = plugin_id
        __props__.__dict__["plugin_provider"] = plugin_provider
        __props__.__dict__["plugin_provider_version"] = plugin_provider_version
        __props__.__dict__["schedulable"] = schedulable
        __props__.__dict__["secrets"] = secrets
        __props__.__dict__["snapshot_id"] = snapshot_id
        __props__.__dict__["topologies"] = topologies
        __props__.__dict__["topology_request"] = topology_request
        __props__.__dict__["type"] = type
        __props__.__dict__["volume_id"] = volume_id
        return ExternalVolume(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def capabilities(self) -> pulumi.Output[Sequence['outputs.ExternalVolumeCapability']]:
        """
        `(``Capability``: <required>)` - Options for validating the capability of a volume.
        """
        return pulumi.get(self, "capabilities")

    @property
    @pulumi.getter(name="capacityMax")
    def capacity_max(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: <optional>)` - Option to signal a maximum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_max")

    @property
    @pulumi.getter(name="capacityMin")
    def capacity_min(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: <optional>)` - Option to signal a minimum volume size. This may not be supported by all storage providers.
        """
        return pulumi.get(self, "capacity_min")

    @property
    @pulumi.getter(name="cloneId")
    def clone_id(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: <optional>)` - The external ID of an existing volume to restore. If ommited, the volume will be created from scratch. Conflicts with `snapshot_id`.
        """
        return pulumi.get(self, "clone_id")

    @property
    @pulumi.getter(name="controllerRequired")
    def controller_required(self) -> pulumi.Output[bool]:
        """
        `(boolean)`
        """
        return pulumi.get(self, "controller_required")

    @property
    @pulumi.getter(name="controllersExpected")
    def controllers_expected(self) -> pulumi.Output[int]:
        """
        `(integer)`
        """
        return pulumi.get(self, "controllers_expected")

    @property
    @pulumi.getter(name="controllersHealthy")
    def controllers_healthy(self) -> pulumi.Output[int]:
        """
        `(integer)`
        """
        return pulumi.get(self, "controllers_healthy")

    @property
    @pulumi.getter(name="mountOptions")
    def mount_options(self) -> pulumi.Output[Optional['outputs.ExternalVolumeMountOptions']]:
        """
        `(block: optional)` Options for mounting `block-device` volumes without a pre-formatted file system.
        """
        return pulumi.get(self, "mount_options")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        `(string: <required>)` - The display name for the volume.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def namespace(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: "default")` - The namespace in which to register the volume.
        """
        return pulumi.get(self, "namespace")

    @property
    @pulumi.getter(name="nodesExpected")
    def nodes_expected(self) -> pulumi.Output[int]:
        """
        `(integer)`
        """
        return pulumi.get(self, "nodes_expected")

    @property
    @pulumi.getter(name="nodesHealthy")
    def nodes_healthy(self) -> pulumi.Output[int]:
        """
        `(integer)`
        """
        return pulumi.get(self, "nodes_healthy")

    @property
    @pulumi.getter
    def parameters(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings passed directly to the CSI plugin to configure the volume.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="pluginId")
    def plugin_id(self) -> pulumi.Output[str]:
        """
        `(string: <required>)` - The ID of the Nomad plugin for registering this volume.
        """
        return pulumi.get(self, "plugin_id")

    @property
    @pulumi.getter(name="pluginProvider")
    def plugin_provider(self) -> pulumi.Output[str]:
        """
        `(string)`
        """
        return pulumi.get(self, "plugin_provider")

    @property
    @pulumi.getter(name="pluginProviderVersion")
    def plugin_provider_version(self) -> pulumi.Output[str]:
        """
        `(string)`
        """
        return pulumi.get(self, "plugin_provider_version")

    @property
    @pulumi.getter
    def schedulable(self) -> pulumi.Output[bool]:
        """
        `(boolean)`
        """
        return pulumi.get(self, "schedulable")

    @property
    @pulumi.getter
    def secrets(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        `(map[string]string: optional)` An optional key-value map of strings used as credentials for publishing and unpublishing volumes.
        """
        return pulumi.get(self, "secrets")

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: <optional>)` - The external ID of a snapshot to restore. If ommited, the volume will be created from scratch. Conflicts with `clone_id`.
        """
        return pulumi.get(self, "snapshot_id")

    @property
    @pulumi.getter
    def topologies(self) -> pulumi.Output[Sequence['outputs.ExternalVolumeTopology']]:
        """
        `(List of topologies)`
        """
        return pulumi.get(self, "topologies")

    @property
    @pulumi.getter(name="topologyRequest")
    def topology_request(self) -> pulumi.Output[Optional['outputs.ExternalVolumeTopologyRequest']]:
        """
        `(``TopologyRequest``: <optional>)` - Specify locations (region, zone, rack, etc.) where the provisioned volume is accessible from.
        """
        return pulumi.get(self, "topology_request")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[Optional[str]]:
        """
        `(string: <required>)` - The type of the volume. Currently, only `csi` is supported.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="volumeId")
    def volume_id(self) -> pulumi.Output[str]:
        """
        `(string: <required>)` - The unique ID of the volume.
        """
        return pulumi.get(self, "volume_id")

